/*
 * GPUJX^tB^pGtFNgt@C
 *   {̂ => http://www.geocities.jp/mosd7500/aviu.html
 *   t@CKɕύXĖ{̂ƓꏊɒuĎg܂
 *
 * NLM̎ɂẮANVIDIÄȉ̕уTvQƂA
 * ۂ̃R[hقڂ̂܂ܗpĂ܂B
 * [URI] http://developer.download.nvidia.com/compute/cuda/1_1/Website/projects/imageDenoising/doc/imageDenoising.pdf
 *
 * :
 *  t@C̃[hɃRpCs߁ANɂȂ莞Ԃ
 *  ꍇ܂B́A炭[v݂邽߂Ȃ̂ŁA
 *  svł΃[v񐔂ŒlɂƉ邩܂B
 *  ܂́ARpCςݔ"*.fxo"ĝ߂܂B
 *  ps3.0ȍ~T|[gGPUiGeForce6,RadeonX1xxxȍ~jKvłB
 */

/*
 * Copyright 1993-2007 NVIDIA Corporation.  All rights reserved.
 *
 * NOTICE TO USER:
 *
 * This source code is subject to NVIDIA ownership rights under U.S. and
 * international Copyright laws.  Users and possessors of this source code
 * are hereby granted a nonexclusive, royalty-free license to use this code
 * in individual and commercial software.
 *
 * NVIDIA MAKES NO REPRESENTATION ABOUT THE SUITABILITY OF THIS SOURCE
 * CODE FOR ANY PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR
 * IMPLIED WARRANTY OF ANY KIND.  NVIDIA DISCLAIMS ALL WARRANTIES WITH
 * REGARD TO THIS SOURCE CODE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY, NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE.
 * IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL,
 * OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
 * OF USE, DATA OR PROFITS,  WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION,  ARISING OUT OF OR IN CONNECTION WITH THE USE
 * OR PERFORMANCE OF THIS SOURCE CODE.
 *
 * U.S. Government End Users.   This source code is a "commercial item" as
 * that term is defined at  48 C.F.R. 2.101 (OCT 1995), consisting  of
 * "commercial computer  software"  and "commercial computer software
 * documentation" as such terms are  used in 48 C.F.R. 12.212 (SEPT 1995)
 * and is provided to the U.S. Government only as a commercial end item.
 * Consistent with 48 C.F.R.12.212 and 48 C.F.R. 227.7202-1 through
 * 227.7202-4 (JUNE 1995), all U.S. Government End Users acquire the
 * source code with only those rights set forth herein.
 *
 * Any use of this source code in individual and commercial software must
 * include, in the user documentation and internal comments to the code,
 * the above Disclaimer and U.S. Government End Users Notice.
 */

int4 FilterVersion
 <
	string name       = "NLM eXg(GPU)";
	string ex_info    = "NLM test by N099";
	string img_format = "F32";
 > = { 0, 1, 0, 0 };

//s߂̒T͈
int Track0
<
	string name = "͈";
	int min = 1;
	int max = 8;
	int def = 3;
>;

//ubNm̋ɑ΂d
float Track1
<
	string name = "";
	int min = 0;
	int max = 256;
	int def = 0;
	string usage = "normalize";
>;

//ubNł̉fl̘̍aɑ΂d
float Track2
<
	string name = "F";
	int min = 0;
	int max = 256;
	int def = 128;
	string usage = "normalize";
>;

// ʂ̃ubNTCYIł悤ɂ
//#define BLOCK_SIZE
#ifdef BLOCK_SIZE
int Track3
<
	string name = "";
	int min = 0;
	int max = 2;
	int def = 0;
	string usage = "technique";
>;
#endif

texture TxTmp;
sampler2D samTmp =
sampler_state
{
    Texture = <TxTmp>;
    AddressU = Mirror;
    AddressV = Mirror;
    MinFilter = Point;
    MagFilter = Point;
};

float2 PixelKernel0[1] = { 1.0f, 1.0f };
float2 TexelKernel0[1];

// 3x3 block
float4 NLMNvPS3(float2 Tex : TEXCOORD0) : COLOR0
{
	float sumWeights = 0.0f;
	float3 clr = { 0.0f, 0.0f, 0.0f };
	const float InvWnd = 2.0f * Track1 * Track1 / (3.0f * 3.0f);
	float Noise = Track2 + 0.0001f;
	Noise = 1.0f/(Noise * Noise);

	//Cycle through NLM window, surrounding (x, y) texel
	[loop] for(float i = -Track0; i <= Track0; i++){
		[loop] for(float j = -Track0; j <= Track0; j++){
			float2 offsIJ = float2(j, i);
			float weightIJ = 0.0f;

			//Find color distance from (x, y) to (x + j, y + i)
			for(float n = -1; n <= 1; n++){
				for(float m = -1; m <= 1; m++){
					float2 offsNM = float2(m, n);
					weightIJ += length(
						tex2Dlod(samTmp, float4(Tex + (offsIJ + offsNM) * TexelKernel0[0], 0, 0)).rgb
						- tex2Dlod(samTmp, float4(Tex + (offsNM * TexelKernel0[0]), 0, 0)).rgb
					);
				}
			}

			//Derive final weight from color and geometric distance
			weightIJ = exp( -(weightIJ * Noise + (i * i + j * j) * InvWnd) );

			//Accumulate (x + j, y + i) texel color with computed weight
			clr += weightIJ * tex2Dlod(samTmp, float4(Tex + offsIJ * TexelKernel0[0], 0, 0)).rgb;

			//Sum of weights for color normalization to [0..1] range
			sumWeights += weightIJ;
		}
	}

	//Normalize result color by sum of weights
	clr /= sumWeights;

	return float4(clr, 0.0f);
}

technique ProcessImage0
{
	pass P0
	{
		VertexShader = null;
		PixelShader = compile ps_3_0 NLMNvPS3();
		ZEnable = false;
		
		//for nv
		AddressU[0]  = Mirror;
		AddressV[0]  = Mirror;
		MinFilter[0] = Point;
 		MagFilter[0] = Point;
	}
}

#ifdef BLOCK_SIZE

// 5x5 block
float4 NLMNvPS5(float2 Tex : TEXCOORD0) : COLOR0
{
	float sumWeights = 0.0f;
	float3 clr = { 0.0f, 0.0f, 0.0f };
	const float InvWnd = 2.0f * Track1 * Track1 / (5.0f * 5.0f);
	float Noise = Track2 + 0.0001f;
	Noise = 1.0f/(Noise * Noise);

	[loop] for(float i = -Track0; i <= Track0; i++){
		[loop] for(float j = -Track0; j <= Track0; j++){
			float2 offsIJ = float2(j, i);
			float weightIJ = 0.0f;
			for(float n = -2; n <= 2; n++){
				for(float m = -2; m <= 2; m++){
					float2 offsNM = float2(m, n);
					weightIJ += length(
						tex2Dlod(samTmp, float4(Tex + (offsIJ + offsNM) * TexelKernel0[0], 0, 0)).rgb
						- tex2Dlod(samTmp, float4(Tex + (offsNM * TexelKernel0[0]), 0, 0)).rgb
					);
				}
			}

			weightIJ = exp( -(weightIJ * Noise + (i * i + j * j) * InvWnd) );
			clr += weightIJ * tex2Dlod(samTmp, float4(Tex + offsIJ * TexelKernel0[0], 0, 0)).rgb;
			sumWeights += weightIJ;
		}
	}

	return float4(clr / sumWeights, 0.0f);
}

// 7x7 block
float4 NLMNvPS7(float2 Tex : TEXCOORD0) : COLOR0
{
	float sumWeights = 0.0f;
	float3 clr = { 0.0f, 0.0f, 0.0f };
	const float InvWnd = 2.0f * Track1 * Track1 / (7.0f * 7.0f);
	float Noise = Track2 + 0.0001f;
	Noise = 1.0f/(Noise * Noise);

	[loop] for(float i = -Track0; i <= Track0; i++){
		[loop] for(float j = -Track0; j <= Track0; j++){
			float2 offsIJ = float2(j, i);
			float weightIJ = 0.0f;
			for(float n = -3; n <= 3; n++){
				for(float m = -3; m <= 3; m++){
					float2 offsNM = float2(m, n);
					weightIJ += length(
						tex2Dlod(samTmp, float4(Tex + (offsIJ + offsNM) * TexelKernel0[0], 0, 0)).rgb
						- tex2Dlod(samTmp, float4(Tex + (offsNM * TexelKernel0[0]), 0, 0)).rgb
					);
				}
			}

			weightIJ = exp( -(weightIJ * Noise + (i * i + j * j) * InvWnd) );
			clr += weightIJ * tex2Dlod(samTmp, float4(Tex + offsIJ * TexelKernel0[0], 0, 0)).rgb;
			sumWeights += weightIJ;
		}
	}

	return float4(clr / sumWeights, 0.0f);
}

technique ProcessImage1
{
	pass P0
	{
		VertexShader = null;
		PixelShader = compile ps_3_0 NLMNvPS5();
		ZEnable = false;
		
		//for nv
		AddressU[0]  = Mirror;
		AddressV[0]  = Mirror;
		MinFilter[0] = Point;
 		MagFilter[0] = Point;
	}
}

technique ProcessImage2
{
	pass P0
	{
		VertexShader = null;
		PixelShader = compile ps_3_0 NLMNvPS7();
		ZEnable = false;
		
		//for nv
		AddressU[0]  = Mirror;
		AddressV[0]  = Mirror;
		MinFilter[0] = Point;
 		MagFilter[0] = Point;
	}
}
#endif // #ifdef BLOCK_SIZE

